clear all
#delimit;
version 16.1;

set more off;

*2011 POPULATION CENSUS;

infix cpro 1-2 weight 20-33 anac 36-39 age 40-42 sexo 43 naci 44-46 cpaisn 47-49 cpron 50-51 anoc 63-66 esreal 113-114 rela 123 situ 129 str5 cse 130-134 tenen 159 str1 tipoper 194 using MicrodatosCP_NV_per_nacional_3VAR.txt;

keep if (age>=18 & age<=79);
drop if cpro>50;
drop if cpron>50;
drop if cse=="18"; /*drops military personnel*/

gen a0200=.; /*region of birth*/
replace a0200=1 if (cpron==4 | cpron==11 | cpron==14 | cpron==18 | cpron==21 | cpron==23 | cpron==29 | cpron==41);
replace a0200=2 if (cpron==22 | cpron==44 | cpron==50);
replace a0200=3 if cpron==33;
replace a0200=4 if cpron==7;
replace a0200=5 if (cpron==35 | cpron==38);
replace a0200=6 if cpron==39;
replace a0200=7 if (cpron==5 | cpron==9 | cpron==24 | cpron==34 | cpron==37 | cpron==40 | cpron==42 | cpron==47 | cpron==49);
replace a0200=8 if (cpron==2 | cpron==13 | cpron==16 | cpron==19 | cpron==45);
replace a0200=9 if (cpron==8 | cpron==17 | cpron==25 | cpron==43);
replace a0200=10 if (cpron==3 | cpron==12 | cpron==46);
replace a0200=11 if (cpron==6 | cpron==10);
replace a0200=12 if (cpron==15 | cpron==27 | cpron==32 | cpron==36);
replace a0200=13 if cpron==28;
replace a0200=14 if cpron==30;
replace a0200=15 if cpron==31;
replace a0200=16 if (cpron==1 | cpron==20 | cpron==48);
replace a0200=17 if cpron==26;

gen ccaaf=.; /*region of residence*/
replace ccaaf=1 if (cpro==4 | cpro==11 | cpro==14 | cpro==18 | cpro==21 | cpro==23 | cpro==29 | cpro==41);
replace ccaaf=2 if (cpro==22 | cpro==44 | cpro==50);
replace ccaaf=3 if cpro==33;
replace ccaaf=4 if cpro==7;
replace ccaaf=5 if (cpro==35 | cpro==38);
replace ccaaf=6 if cpro==39;
replace ccaaf=7 if (cpro==5 | cpro==9 | cpro==24 | cpro==34 | cpro==37 | cpro==40 | cpro==42 | cpro==47 | cpro==49);
replace ccaaf=8 if (cpro==2 | cpro==13 | cpro==16 | cpro==19 | cpro==45);
replace ccaaf=9 if (cpro==8 | cpro==17 | cpro==25 | cpro==43);
replace ccaaf=10 if (cpro==3 | cpro==12 | cpro==46);
replace ccaaf=11 if (cpro==6 | cpro==10);
replace ccaaf=12 if (cpro==15 | cpro==27 | cpro==32 | cpro==36);
replace ccaaf=13 if cpro==28;
replace ccaaf=14 if cpro==30;
replace ccaaf=15 if cpro==31;
replace ccaaf=16 if (cpro==1 | cpro==20 | cpro==48);
replace ccaaf=17 if cpro==26;

gen male=0;
replace male=1 if sexo==1;

gen age_cat=0;
replace age_cat=1 if (age>=25 & age<=44);
replace age_cat=2 if (age>=45 & age<=64);
replace age_cat=3 if (age>=65 & age<=79);

gen educ_cat=0;
replace educ_cat=1 if esreal==4;
replace educ_cat=2 if (esreal>=5 & esreal<=7);
replace educ_cat=3 if (esreal>=8 & esreal<=12);

gen lfs_cat=0;
replace lfs_cat=1 if (rela==1 & (situ==1 | situ==2)); /*self-employed*/
replace lfs_cat=2 if (rela==1 & (situ==3 | situ==4 | situ==5 | situ==6)); /*employee*/
replace lfs_cat=5 if (rela==2 | rela==3); /*unemployed*/

gen owner_cat=0;
replace owner_cat=1 if (tenen==1 | tenen==2); /*owner through purchase*/
replace owner_cat=2 if tenen==3; /*owner through inheritance or gift*/
replace owner_cat=3 if tenen==4; /*tenant*/

gen diffan=anoc-anac;

gen migrant=(ccaaf!=a0200);

gen migrantb=((diffan>=14 & anoc<1980) | (diffan>=16 & anoc>=1980));

mean migrant migrantb [pweight=weight];

mean migrant if migrantb==1 [pweight=weight];

mean migrant if migrantb==0 [pweight=weight];

keep male anac age age_cat educ_cat a0200 lfs_cat migrant* owner_cat weight;

save census_data, replace;

clear;

*ECF;

use ecf_2016_e.dta;

rename a0000 male;
rename a1100 educ;
rename a0400 anac;

*Selection;

keep if a0100==1; /*born in Spain*/

keep if ((male==0 | male==1) & (age>=18 & age<=79) & (educ>=1 & educ<=9));

drop if a0200==-5; /*missing region of birth*/

drop if ((d0300!=-97 & d0300!=0 & d0300!=1) | (d0300==0 & (d0500!=-97 & d0500!=0 & d0500!=1)) | (d0300==1 & (d0400!=-97 & d0400!=0 & d0400!=1))); /*the DK answer may be informative*/

drop if (anac<1936 | anac>1998);

drop if (a1500<1 | a1500>22);

drop if (d0600<0 | d0600>100);

drop if (d0105<1 | d0105>5);

drop if (e0200a==-3 & e0200b==-3 & e0200c==-3 & e0200d==-3 & e0200e==-3); /*cannot read the graph*/

drop if (e0401==-3 & e0402==-3 & e0403==-3); /*cannot read the text*/

drop if (i0100<1 | i0100>4);

drop if (a1400<1 | a1400>5);

drop if a1800==0; /*armed forces occupations*/

*Variables;

replace a0200=96 if a0200==-96; /*factor variables cannot contain negative values*/

gen included=(a0200!=96);

gen migrant=(ccaaf!=a0200) if included==1;

gen allmigrant=migrant;
replace allmigrant=1 if included==0; /*the anonymized are assumed to be migrants in certain calculations*/

gen age_cat=0;
replace age_cat=1 if (age>=25 & age<=44);
replace age_cat=2 if (age>=45 & age<=64);
replace age_cat=3 if (age>=65 & age<=79);

gen educ_cat=0;
replace educ_cat=1 if educ==3;
replace educ_cat=2 if (educ>=4 & educ<=6);
replace educ_cat=3 if (educ>=7 & educ<=9);

gen impatience_cat=.;
replace impatience_cat=0 if (d0300==0 & (d0500==0 | d0500==-97));
replace impatience_cat=1 if (d0300==-97 | (d0300==0 & d0500==1));
replace impatience_cat=2 if (d0300==1 & (d0400==0 | d0400==-97));
replace impatience_cat=3 if (d0300==1 & d0400==1);

gen impatience_binary=.;
replace impatience_binary=0 if ((d0300==0 & (d0500==0 | d0500==-97)) | (d0300==-97 | (d0300==0 & d0500==1)));
replace impatience_binary=1 if ((d0300==1 & (d0400==0 | d0400==-97)) | (d0300==1 & d0400==1));

gen MPC=d0600;

gen risk_score=d0105;

gen numerate=0;
replace numerate=1 if (e0200a==1 & e0200b==1 & e0200c==0 & e0200d==0 & e0200e==0);

gen literate=0;
replace literate=1 if ((e0401==3 & e0402!=18 & e0403!=2) | (e0401!=3 & e0402==18 & e0403!=2) | (e0401!=3 & e0402!=18 & e0403==2));
replace literate=2 if ((e0401==3 & e0402==18 & e0403!=2) | (e0401==3 & e0402!=18 & e0403==2) | (e0401!=3 & e0402==18 & e0403==2));
replace literate=3 if (e0401==3 & e0402==18 & e0403==2);

gen OK_CRT=0;
replace OK_CRT=1 if e0300==5;

gen lfs_cat=0;
replace lfs_cat=1 if (a1500==1 | a1500==11 | a1500==12); /*self-employed*/
replace lfs_cat=2 if (a1500==2 | a1500==21 | a1500==22); /*employee*/
replace lfs_cat=5 if a1500==5; /*unemployed*/

gen owner_cat=0; /*other housing tenure*/
replace owner_cat=1 if i0100==1; /*owner through purchase*/
replace owner_cat=2 if i0100==2; /*owner through inheritance or gift*/
replace owner_cat=3 if i0100==3; /*tenant*/

gen nbooks=a1400;

gen double pop_2017=.; /*in millions, from INE Cifras Oficiales de Población, Continuous Padrón Municipal at January 1, 2017*/
replace pop_2017=8.379820 if ccaaf==1;
replace pop_2017=1.308750 if ccaaf==2;
replace pop_2017=1.034960 if ccaaf==3;
replace pop_2017=1.115999 if ccaaf==4;
replace pop_2017=2.108121 if ccaaf==5;
replace pop_2017=0.580295 if ccaaf==6;
replace pop_2017=2.425801 if ccaaf==7;
replace pop_2017=2.031479 if ccaaf==8;
replace pop_2017=7.555830 if ccaaf==9;
replace pop_2017=4.941509 if ccaaf==10;
replace pop_2017=1.079920 if ccaaf==11;
replace pop_2017=2.708339 if ccaaf==12;
replace pop_2017=6.507184 if ccaaf==13;
replace pop_2017=1.470273 if ccaaf==14;
replace pop_2017=0.643234 if ccaaf==15;
replace pop_2017=2.194158 if ccaaf==16;
replace pop_2017=0.315381 if ccaaf==17;

*COMPARISON BETWEEN ANONYMIZED AND NON ANONYMIZED OBS;

foreach var of varlist impatience_cat male educ_cat nbooks ccaaf {;
	tabulate included `var', row nofreq chi2; /*Pearson chi square test*/
};

foreach var of varlist age numerate literate OK_CRT risk_score MPC {;
	display "variable `var'";
	ttest `var', by(included) welch; /*t test of equal means allowing for unequal variances*/
};

*DESCRIPTIVES;

mean migrant [pweight=weight] if included==1;
mean allmigrant [pweight=weight];

sum migrant male age anac numerate literate OK_CRT MPC risk_score if included==1;
tab impatience_cat if included==1;
tab educ_cat if included==1;
tab a0200 if included==1;
tab nbooks if included==1;
tab lfs_cat if included==1;
tab owner_cat if included==1;

tab impatience_cat;
tabulate migrant impatience_cat if included==1, row nofreq chi2; /*Pearson chi square test*/

/*1. Chi-square goodness-of-fit test, lognormal distribution*/

gen unos=1;

gen double lower=.;
gen double upper=.;

replace lower=ln(0.0494) if impatience_cat==1;
replace lower=ln(0.0976) if impatience_cat==2;
replace lower=ln(0.4495) if impatience_cat==3;
replace upper=ln(0.0494) if impatience_cat==0;
replace upper=ln(0.0976) if impatience_cat==1;
replace upper=ln(0.4495) if impatience_cat==2;

intreg lower upper if included==1;
scalar obs=e(N);
scalar miu=_b[model:_cons];
scalar sigma=exp(_b[lnsigma:_cons]);
scalar sigma2=sigma*sigma;
scalar meanR=exp(miu+(0.5*sigma2));
predict phat if included==1, pr(lower,upper);
replace phat=round(obs*phat,1);

sort included impatience_cat;
by included impatience_cat: egen contar=count(unos) if included==1;
gen sumas=((contar-phat)^2)/phat;
sort included impatience_cat;
by included impatience_cat: replace sumas=. if _n!=1;
gen prueba=sum(sumas) if included==1;
sum prueba, d;
scalar chi2=invchi2tail(1,0.10);
scalar list chi2;
/*keep if sumas!=.;
order contar phat;
exit;
*/
scalar drop obs chi2;
drop phat contar sumas prueba;

gen double ams=(lower-miu)/sigma;
gen double bms=(upper-miu)/sigma;

gen double cmeanR=.; /*following Wang et al. 2012 and lognormal distribution in wikipedia*/
replace cmeanR=meanR*normal(-sigma+bms)/normal(bms) if impatience_cat==0;
replace cmeanR=meanR*(normal(-sigma+bms)-normal(-sigma+ams))/(normal(bms)-normal(ams)) if impatience_cat==1;
replace cmeanR=meanR*(normal(-sigma+bms)-normal(-sigma+ams))/(normal(bms)-normal(ams)) if impatience_cat==2;
replace cmeanR=meanR*normal(sigma-ams)/(1-normal(ams)) if impatience_cat==3;

*REGRESSION ANALYSIS;

replace MPC=MPC/10; /*divided by 10*/

gen sample_id=-1;

keep male anac age age_cat educ_cat migrant a0200 impatience_* MPC risk_score numerate literate OK_CRT lfs_cat owner_cat sample_id weight nbooks included pop_2017 cmeanR;

append using census_data;

replace sample_id=0 if migrantb==0;
replace sample_id=1 if migrantb==1;

sum;

gen false_pos=(migrant==1) if sample_id==0;
gen false_neg=(migrant==0) if sample_id==1;

*Errors of commission;

mkspline anacsp = anac, cubic knots(1935 1940 1945 1950 1955 1960 1965 1970 1975 1980 1985 1990);

probit false_pos anacsp* i.a0200 a0200#c.anacsp* i.educ_cat i.lfs_cat if sample_id==0, vce(robust);
predict double alpha0_i if included==1, pr;

*Errors of omission;

probit false_neg age c.age#c.age c.age#c.age#c.age i.a0200 a0200#c.age a0200#c.age#c.age a0200#c.age#c.age#c.age i.male i.educ_cat i.lfs_cat i.owner_cat if sample_id==1, vce(robust);
predict double alpha1_i if included==1, pr;

sum alpha0_i alpha1_i;

keep if sample_id==-1;

gen double omas_i = 1 - alpha0_i - alpha1_i;

tab a0200, gen(da0200_);

constraint 1 alpha0_i = 1;

program PP_Probit_lf2;
	version 16.1;
	args todo b lnfj g1 H;
	tempvar xb q lambda A;
	mleval `xb' = `b';
	quietly {;
		generate double `q' = (2*$ML_y1) - 1;
		generate double `A' = (alpha0_i*$ML_y1) + (alpha1_i*(1-$ML_y1)) + (omas_i*normal(`q'*`xb'));
		generate double `lambda' = `q'*omas_i*normalden(`q'*`xb')/`A';
		replace `lnfj' = ln(`A');
		if (`todo'==0) exit;
		replace `g1' = `lambda';
		if (`todo'==1) exit;
		mlmatsum `lnfj' `H' = -`lambda'*(`lambda'+`xb');
	};
end;

program PP_Heckprobit_lf2;
	version 16.1;
	args todo b lnfj g1 g2 g3 H;
	tempvar z1 z2 q1 q2 w1 w2 rhos delta v1 v2 ge1 ge2 bden qf cc A;
	tempname ihtrho;
	mleval `z1' = `b', eq(1);
	mleval `z2' = `b', eq(2);
	mleval `ihtrho' = `b', eq(3) scalar;
	quietly {;
		generate double `q1' = (2*$ML_y1) - 1;
		generate double `q2' = (2*$ML_y2) - 1;
		generate double `w1' = `q1'*`z1';
		generate double `w2' = `q2'*`z2';
		generate double `rhos' = `q1'*`q2'*tanh(`ihtrho');
		generate double `delta' = 1/sqrt(1-(`rhos'^2));
		generate double `v1' = `delta'*(`w2'-(`rhos'*`w1'));
		generate double `v2' = `delta'*(`w1'-(`rhos'*`w2'));
		generate double `ge1' = normalden(`w1')*normal(`v1');
		generate double `ge2' = normalden(`w2')*normal(`v2');
		generate double `bden' = normalden(`w2')*normalden(`v2')*`delta';
		generate double `qf' = (`delta'^2)*`rhos'*(1-((`delta'^2)*((`w1'^2)+(`w2'^2)-(2*`rhos'*`w1'*`w2'))));
		generate double `cc' = (alpha0_i*$ML_y1) + (alpha1_i*(1-$ML_y1));
		generate double `A' = (omas_i*binormal(`w1',`w2',`rhos'))+(`cc'*normal(`w2'));
		replace `lnfj' = ln(`A') if $ML_y2 == 1;
		replace `lnfj' = ln(normal(`w2')) if $ML_y2 ==0;
		if (`todo'==0) exit;
		replace `g1' = omas_i*`q1'*`ge1'/`A' if $ML_y2 == 1;
		replace `g1' = 0 if $ML_y2 == 0;
		replace `g2' = `q2'*((omas_i*`ge2')+(`cc'*normalden(`w2')))/`A' if $ML_y2 == 1;
		replace `g2' = `q2'*normalden(`w2')/normal(`w2') if $ML_y2 == 0;
		replace `g3' = (omas_i*`q1'*`q2'*`bden'/`A')*(1-(tanh(`ihtrho')^2)) if $ML_y2 == 1;
		replace `g3' = 0 if $ML_y2 == 0;
		if (`todo'==1) exit;
		tempvar h11 h12 h13 h22 h23 h33;
		gen double `h11' = -omas_i*((`w1'*`ge1'/`A')+(`rhos'*`bden'/`A')+(omas_i*((`ge1'/`A')^2))) if $ML_y2 == 1;
		replace `h11' = 0 if $ML_y2 == 0;
		gen double `h12' = omas_i*`q1'*`q2'*((`bden'/`A')-(omas_i*`ge1'*`ge2'/(`A'^2))-(`cc'*normalden(`w2')*`ge1'/(`A'^2))) if $ML_y2 == 1;
		replace `h12' = 0 if $ML_y2 == 0;
		gen double `h13' = (omas_i*`q2'*`bden'*((`rhos'*`delta'*`v1')-`w1'-(omas_i*`ge1'/`A'))/`A')*(1-(tanh(`ihtrho')^2)) if $ML_y2 == 1;
		replace `h13' = 0 if $ML_y2 == 0;
		gen double `h22' = -(omas_i*`w2'*`ge2'/`A')-(omas_i*`rhos'*`bden'/`A')-(`cc'*`w2'*normalden(`w2')/`A')-((((omas_i*`ge2')+(`cc'*normalden(`w2')))/`A')^2) if $ML_y2 == 1;
		replace `h22' = -normalden(`w2')*(`w2'+(normalden(`w2')/normal(`w2')))/normal(`w2') if $ML_y2 == 0;
		gen double `h23' = (omas_i*`q1'*`bden'*((`rhos'*`delta'*`v2')-`w2'-(((omas_i*`ge2')+(`cc'*normalden(`w2')))/`A'))/`A')*(1-(tanh(`ihtrho')^2)) if $ML_y2 == 1;
		replace `h23' = 0 if $ML_y2 == 0;
		gen double `h33' = (((omas_i*`bden'*(`qf'+((`delta'^2)*`w1'*`w2')-(omas_i*`bden'/`A'))/`A')*(1-(tanh(`ihtrho')^2)))-(2*tanh(`ihtrho')*(omas_i*`q1'*`q2'*`bden'/`A')))*(1-(tanh(`ihtrho')^2)) if $ML_y2 == 1;
		replace `h33' = 0 if $ML_y2 == 0;
		tempname d11 d12 d13 d22 d23 d33;
		mlmatsum `lnfj' `d11' = `h11', eq(1);
		mlmatsum `lnfj' `d12' = `h12', eq(1,2);
		mlmatsum `lnfj' `d13' = `h13', eq(1,3);
		mlmatsum `lnfj' `d22' = `h22', eq(2);
		mlmatsum `lnfj' `d23' = `h23', eq(2,3);
		mlmatsum `lnfj' `d33' = `h33', eq(3);
		matrix `H' = (`d11',`d12',`d13' \ `d12'',`d22',`d23' \ `d13'',`d23'',`d33');
	};
end;

program mybutler_lf2;
	version 16.1;
	args todo b lnfj g1 g2 H;
	tempvar z1 z2 den1 den2;
	mleval `z1' = `b', eq(1);
	mleval `z2' = `b', eq(2);
	quietly {;
		gen double `den1' = ((1-alpha0_i)*normal(`z2'))-(omas_i*normal(`z1'));
		gen double `den2' = (alpha0_i*normal(`z2'))+(omas_i*normal(`z1'));
		replace `lnfj' = ln(normal(-`z2')) if $ML_y2 == 0;
		replace `lnfj' = ln(alpha1_i*normal(`z2')) if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `lnfj' = ln(`den1') if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `lnfj' = ln((1-alpha1_i)*normal(`z2')) if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `lnfj' = ln(`den2') if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		if (`todo'==0) exit;
		replace `g1' = 0 if $ML_y2 == 0;
		replace `g1' = 0 if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `g1' = -omas_i*normalden(`z1')/`den1' if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `g1' = 0 if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `g1' = omas_i*normalden(`z1')/`den2' if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		replace `g2' = -normalden(-`z2')/normal(-`z2') if $ML_y2 == 0;
		replace `g2' = normalden(`z2')/normal(`z2') if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `g2' = (1-alpha0_i)*normalden(`z2')/`den1' if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `g2' = normalden(`z2')/normal(`z2') if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `g2' = alpha0_i*normalden(`z2')/`den2' if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		if (`todo'==1) exit;
		tempvar h11 h12 h22;
		gen double `h11' = 0 if $ML_y2 == 0;
		replace `h11' = 0 if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `h11' = omas_i*normalden(`z1')*(`z1'-(omas_i*normalden(`z1')/`den1'))/`den1' if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `h11' = 0 if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `h11' = -omas_i*normalden(`z1')*(`z1'+(omas_i*normalden(`z1')/`den2'))/`den2' if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		gen double `h12' = 0 if $ML_y2 == 0;
		replace `h12' = 0 if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `h12' = omas_i*normalden(`z1')*(1-alpha0_i)*normalden(`z2')/(`den1'^2) if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `h12' = 0 if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `h12' = -omas_i*normalden(`z1')*alpha0_i*normalden(`z2')/(`den2'^2) if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		gen double `h22' = -normalden(-`z2')*(-`z2'+(normalden(-`z2')/normal(-`z2')))/normal(-`z2') if $ML_y2 == 0;
		replace `h22' = -normalden(`z2')*(`z2'+(normalden(`z2')/normal(`z2')))/normal(`z2') if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' >= `z2');
		replace `h22' = -(1-alpha0_i)*normalden(`z2')*(`z2'+((1-alpha0_i)*normalden(`z2')/`den1'))/`den1' if ($ML_y2 == 1 & $ML_y1 == 0 & `z1' < `z2');
		replace `h22' = -normalden(`z2')*(`z2'+(normalden(`z2')/normal(`z2')))/normal(`z2') if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' >= `z2');
		replace `h22' = -alpha0_i*normalden(`z2')*(`z2'+(alpha0_i*normalden(`z2')/`den2'))/`den2' if ($ML_y2 == 1 & $ML_y1 == 1 & `z1' < `z2');
		tempname d11 d12 d22;
		mlmatsum `lnfj' `d11' = `h11', eq(1);
		mlmatsum `lnfj' `d12' = `h12', eq(1,2);
		mlmatsum `lnfj' `d22' = `h22', eq(2);
		matrix `H' = (`d11',`d12' \ `d12'',`d22');
	};
end;

*Selection equation;

probit included i.impatience_cat i.male age pop_2017, vce(robust);
matrix coef_sel1=e(b);
matrix colnames coef_sel1 = eq2:;
predict double xbsel1, xb;

probit included i.impatience_cat i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017, vce(robust);
matrix coef_sel2=e(b);
matrix colnames coef_sel2 = eq2:;
predict double xbsel2, xb;

probit included i.impatience_binary i.male age pop_2017, vce(robust);
matrix coef_sel3=e(b);
matrix colnames coef_sel3 = eq2:;
predict double xbsel3, xb;

probit included i.impatience_binary i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017, vce(robust);
matrix coef_sel4=e(b);
matrix colnames coef_sel4 = eq2:;
predict double xbsel4, xb;

probit included cmeanR c.cmeanR#c.cmeanR i.male age pop_2017, vce(robust);
matrix coef_sel5=e(b);
matrix colnames coef_sel5 = eq2:;
predict double xbsel5, xb;

probit included cmeanR c.cmeanR#c.cmeanR i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017, vce(robust);
matrix coef_sel6=e(b);
matrix colnames coef_sel6 = eq2:;
predict double xbsel6, xb;

forvalues j = 1(1)6 {;
	gen double IMR`j'=normalden(xbsel`j')/normal(xbsel`j') if included==1;
	gen double omega`j'=IMR`j'*(IMR`j'+xbsel`j') if included==1;
	sum omega`j';
	scalar mean_omega`j'=r(mean);
};

*Linear probability with selection;

cnsreg migrant alpha0_i (impatience_cat male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17)#c.omas_i omas_i c.IMR1#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel1a=coeffull[1,2..85]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel1=coef_lpm_sel1a,add;
predict double res_lpm_sel1 if included==1, residuals;
matrix accum EO1 = res_lpm_sel1 if included==1, noconstant;
scalar coef_rho_lpm_sel1=_b[c.IMR1#c.omas_i]/sqrt((EO1[1,1]/e(N))+((_b[c.IMR1#c.omas_i]^2)*mean_omega1));
if coef_rho_lpm_sel1<=-1 {;
    scalar coef_rho_lpm_sel1=-0.9;
};
else if coef_rho_lpm_sel1>=1 {;
	scalar coef_rho_lpm_sel1=0.9;
};
matrix coef_ihtrho1=(atanh(coef_rho_lpm_sel1));
matrix colnames coef_lpm_sel1 = 0b.impatience_cat 1.impatience_cat 2.impatience_cat 3.impatience_cat 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 _cons;
matrix colnames coef_lpm_sel1 = eq1:;
matrix colnames coef_ihtrho1 = eq3:_cons;

matrix drop coeffull coef_lpm_sel1a add EO1;

cnsreg migrant alpha0_i (impatience_cat male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17 educ_cat nbooks numerate c.literate OK_CRT c.risk_score c.MPC)#c.omas_i omas_i c.IMR2#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel2a=coeffull[1,2..101]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel2=coef_lpm_sel2a,add;
predict double res_lpm_sel2 if included==1, residuals;
matrix accum EO2 = res_lpm_sel2 if included==1, noconstant;
scalar coef_rho_lpm_sel2=_b[c.IMR2#c.omas_i]/sqrt((EO2[1,1]/e(N))+((_b[c.IMR2#c.omas_i]^2)*mean_omega2));
if coef_rho_lpm_sel2<=-1 {;
    scalar coef_rho_lpm_sel2=-0.9;
};
else if coef_rho_lpm_sel2>=1 {;
	scalar coef_rho_lpm_sel2=0.9;
};
matrix coef_ihtrho2=(atanh(coef_rho_lpm_sel2));
matrix colnames coef_lpm_sel2 = 0b.impatience_cat 1.impatience_cat 2.impatience_cat 3.impatience_cat 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 0b.educ_cat 1.educ_cat 2.educ_cat 3.educ_cat 1b.nbooks 2.nbooks 3.nbooks 4.nbooks 5.nbooks 0b.numerate 1.numerate literate 0b.OK_CRT 1.OK_CRT risk_score MPC _cons;
matrix colnames coef_lpm_sel2 = eq1:;
matrix colnames coef_ihtrho2 = eq3:_cons;

matrix drop coeffull coef_lpm_sel2a add EO2;

cnsreg migrant alpha0_i (impatience_binary male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17)#c.omas_i omas_i c.IMR3#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel3a=coeffull[1,2..83]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel3=coef_lpm_sel3a,add;
predict double res_lpm_sel3 if included==1, residuals;
matrix accum EO3 = res_lpm_sel3 if included==1, noconstant;
scalar coef_rho_lpm_sel3=_b[c.IMR3#c.omas_i]/sqrt((EO3[1,1]/e(N))+((_b[c.IMR3#c.omas_i]^2)*mean_omega3));
if coef_rho_lpm_sel3<=-1 {;
    scalar coef_rho_lpm_sel3=-0.9;
};
else if coef_rho_lpm_sel3>=1 {;
	scalar coef_rho_lpm_sel3=0.9;
};
matrix coef_ihtrho3=(atanh(coef_rho_lpm_sel3));
matrix colnames coef_lpm_sel3 = 0b.impatience_binary 1.impatience_binary 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 _cons;
matrix colnames coef_lpm_sel3 = eq1:;
matrix colnames coef_ihtrho3 = eq3:_cons;

matrix drop coeffull coef_lpm_sel3a add EO3;

cnsreg migrant alpha0_i (impatience_binary male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17 educ_cat nbooks numerate c.literate OK_CRT c.risk_score c.MPC)#c.omas_i omas_i c.IMR4#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel4a=coeffull[1,2..99]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel4=coef_lpm_sel4a,add;
predict double res_lpm_sel4 if included==1, residuals;
matrix accum EO4 = res_lpm_sel4 if included==1, noconstant;
scalar coef_rho_lpm_sel4=_b[c.IMR4#c.omas_i]/sqrt((EO4[1,1]/e(N))+((_b[c.IMR4#c.omas_i]^2)*mean_omega4));
if coef_rho_lpm_sel4<=-1 {;
    scalar coef_rho_lpm_sel4=-0.9;
};
else if coef_rho_lpm_sel4>=1 {;
	scalar coef_rho_lpm_sel4=0.9;
};
matrix coef_ihtrho4=(atanh(coef_rho_lpm_sel4));
matrix colnames coef_lpm_sel4 = 0b.impatience_binary 1.impatience_binary 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 0b.educ_cat 1.educ_cat 2.educ_cat 3.educ_cat 1b.nbooks 2.nbooks 3.nbooks 4.nbooks 5.nbooks 0b.numerate 1.numerate literate 0b.OK_CRT 1.OK_CRT risk_score MPC _cons;
matrix colnames coef_lpm_sel4 = eq1:;
matrix colnames coef_ihtrho4 = eq3:_cons;

matrix drop coeffull coef_lpm_sel4a add EO4;

cnsreg migrant alpha0_i (c.cmeanR c.cmeanR#c.cmeanR male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17)#c.omas_i omas_i c.IMR5#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel5a=coeffull[1,2..83]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel5=coef_lpm_sel5a,add;
predict double res_lpm_sel5 if included==1, residuals;
matrix accum EO5 = res_lpm_sel5 if included==1, noconstant;
scalar coef_rho_lpm_sel5=_b[c.IMR5#c.omas_i]/sqrt((EO5[1,1]/e(N))+((_b[c.IMR5#c.omas_i]^2)*mean_omega5));
if coef_rho_lpm_sel5<=-1 {;
    scalar coef_rho_lpm_sel5=-0.9;
};
else if coef_rho_lpm_sel5>=1 {;
	scalar coef_rho_lpm_sel5=0.9;
};
matrix coef_ihtrho5=(atanh(coef_rho_lpm_sel5));
matrix colnames coef_lpm_sel5 = cmeanR c.cmeanR#c.cmeanR 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 _cons;
matrix colnames coef_lpm_sel5 = eq1:;
matrix colnames coef_ihtrho5 = eq3:_cons;

matrix drop coeffull coef_lpm_sel5a add EO5;

cnsreg migrant alpha0_i (c.cmeanR c.cmeanR#c.cmeanR male ib49.age c.da0200_2 c.da0200_3 c.da0200_4 c.da0200_5 c.da0200_6 c.da0200_7 c.da0200_8 c.da0200_9 c.da0200_10 c.da0200_11 c.da0200_12 c.da0200_13 c.da0200_14 c.da0200_15 c.da0200_16 c.da0200_17 educ_cat nbooks numerate c.literate OK_CRT c.risk_score c.MPC)#c.omas_i omas_i c.IMR6#c.omas_i if included==1, constraints(1) noconstant vce(robust);
matrix coeffull=e(b);
matrix coef_lpm_sel6a=coeffull[1,2..99]*2.5;
matrix add=(_b[omas_i]-0.5)*2.5;
matrix coef_lpm_sel6=coef_lpm_sel6a,add;
predict double res_lpm_sel6 if included==1, residuals;
matrix accum EO6 = res_lpm_sel6 if included==1, noconstant;
scalar coef_rho_lpm_sel6=_b[c.IMR6#c.omas_i]/sqrt((EO6[1,1]/e(N))+((_b[c.IMR6#c.omas_i]^2)*mean_omega6));
if coef_rho_lpm_sel6<=-1 {;
    scalar coef_rho_lpm_sel6=-0.9;
};
else if coef_rho_lpm_sel6>=1 {;
	scalar coef_rho_lpm_sel6=0.9;
};
matrix coef_ihtrho6=(atanh(coef_rho_lpm_sel6));
matrix colnames coef_lpm_sel6 = cmeanR c.cmeanR#c.cmeanR 0b.male 1.male 18.age 19.age 20.age 21.age 22.age 23.age 24.age 25.age 26.age 27.age 28.age 29.age 30.age 31.age 32.age 33.age 34.age 35.age 36.age 37.age 38.age 39.age 40.age 41.age 42.age 43.age 44.age 45.age 46.age 47.age 48.age 49b.age 50.age 51.age 52.age 53.age 54.age 55.age 56.age 57.age 58.age 59.age 60.age 61.age 62.age 63.age 64.age 65.age 66.age 67.age 68.age 69.age 70.age 71.age 72.age 73.age 74.age 75.age 76.age 77.age 78.age 79.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 0b.educ_cat 1.educ_cat 2.educ_cat 3.educ_cat 1b.nbooks 2.nbooks 3.nbooks 4.nbooks 5.nbooks 0b.numerate 1.numerate literate 0b.OK_CRT 1.OK_CRT risk_score MPC _cons;
matrix colnames coef_lpm_sel6 = eq1:;
matrix colnames coef_ihtrho6 = eq3:_cons;

matrix drop coeffull coef_lpm_sel6a add EO6;

*PP-Heckprobit;

forvalues j = 1(1)6 {;
	matrix coef_PP_Heckprobit`j'=coef_lpm_sel`j',coef_sel`j',coef_ihtrho`j';
};

ml model lf2 PP_Heckprobit_lf2 (migrant = i.impatience_cat i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = i.impatience_cat i.male age pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit1;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8) difficult;
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values1=e(b);
matrix butler_initvalues1=butler_values1[1,1..94];
ml model lf2 mybutler_lf2 (migrant = i.impatience_cat i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = i.impatience_cat i.male age pop_2017), missing vce(robust);
ml init butler_initvalues1;
ml maximize, nrtolerance(1e-8) tolerance(1e-8) difficult;

ml model lf2 PP_Heckprobit_lf2 (migrant = i.impatience_cat i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = i.impatience_cat i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit2;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values2=e(b);
matrix butler_initvalues2=butler_values2[1,1..126];
ml model lf2 mybutler_lf2 (migrant = i.impatience_cat i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = i.impatience_cat i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017), missing vce(robust);
ml init butler_initvalues2;
ml maximize, nrtolerance(1e-8) tolerance(1e-8) difficult;

ml model lf2 PP_Heckprobit_lf2 (migrant = i.impatience_binary i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = i.impatience_binary i.male age pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit3;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8) difficult;
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values3=e(b);
matrix butler_initvalues3=butler_values3[1,1..90];
ml model lf2 mybutler_lf2 (migrant = i.impatience_binary i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = i.impatience_binary i.male age pop_2017), missing vce(robust);
ml init butler_initvalues3;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);

ml model lf2 PP_Heckprobit_lf2 (migrant = i.impatience_binary i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = i.impatience_binary i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit4;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values4=e(b);
matrix butler_initvalues4=butler_values4[1,1..122];
ml model lf2 mybutler_lf2 (migrant = i.impatience_binary i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = i.impatience_binary i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017), missing vce(robust);
ml init butler_initvalues4;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);

ml model lf2 PP_Heckprobit_lf2 (migrant = cmeanR c.cmeanR#c.cmeanR i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = cmeanR c.cmeanR#c.cmeanR i.male age pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit5;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8) difficult;
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values5=e(b);
matrix butler_initvalues5=butler_values5[1,1..90];
ml model lf2 mybutler_lf2 (migrant = cmeanR c.cmeanR#c.cmeanR i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17) (included = cmeanR c.cmeanR#c.cmeanR i.male age pop_2017), missing vce(robust);
ml init butler_initvalues5;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);

ml model lf2 PP_Heckprobit_lf2 (migrant = cmeanR c.cmeanR#c.cmeanR i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = cmeanR c.cmeanR#c.cmeanR i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017) (), missing vce(robust);
ml init coef_PP_Heckprobit6;
ml search;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);
nlcom (rho: tanh(_b[eq3:_cons]));
/*predict x1b1 if included==1, xb equation(#1);
predict x2b2, xb equation(#2);
count if (x1b1>=x2b2 & included==1);
*/
matrix butler_values6=e(b);
matrix butler_initvalues6=butler_values6[1,1..122];
ml model lf2 mybutler_lf2 (migrant = cmeanR c.cmeanR#c.cmeanR i.male ib49.age da0200_2 da0200_3 da0200_4 da0200_5 da0200_6 da0200_7 da0200_8 da0200_9 da0200_10 da0200_11 da0200_12 da0200_13 da0200_14 da0200_15 da0200_16 da0200_17 i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC) (included = cmeanR c.cmeanR#c.cmeanR i.male age i.educ_cat i.nbooks i.numerate literate i.OK_CRT risk_score MPC pop_2017), missing vce(robust);
ml init butler_initvalues6;
ml maximize, nrtolerance(1e-8) tolerance(1e-8);

clear all;